# -*- coding: utf-8 -*-
"""
Created on Fri Sep  9 14:22:41 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

"""
from future import standard_library
standard_library.install_aliases()
"""
from builtins import object
class transformSet(object):
    repository = {}
    
    def __init__(self):
        self.type = 'transformSet'
        self.map = {}
        self.excess = {}
        self.current = None
        return
        
    def printTransf(self):
        print('transforms:')
        for i in self.map:
            print('--', i)
            self.map[i].printTransf()
            
    def duplicate(self):
        newTr = transformSet()
        for i in self.map:
            newTr.map[i] = self.map[i].duplicate()
        return newTr
        
    def retrieve(self, var):
        return transformSet.repository[var]
    
    def deposit(self, var):
        transformSet.repository[var] = self
        
    def retrieveTransform(self, clss):
        try:
            """
            return self.map[clss.type]
            """
            if self.current is None or clss.type == 'map-parametric':
                return self.map[clss.type]
            else:
                return self.map[self.current+'=|='+clss.type]
        except KeyError:
            return None
        
    def add(self, transform):
        """
        self.map[transform.type] = transform
        """
        if transform.id is None:
            self.map[transform.type] = transform
        else:
            self.map[transform.id+'=|='+transform.type] = transform
        
    def addExcess(self, transform):
        self.excess[transform.__class__] = transform
        