# -*- coding: utf-8 -*-
"""
Created on Tue Sep  6 12:38:27 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from builtins import str
"""
from future import standard_library
standard_library.install_aliases()
"""
from builtins import object
from copy import copy

class distinguishable(object):
    class elm(object):
        def __init__(self, codescriptor):
            self.individual = codescriptor
            self.forms = {}
            
        def __repr__(self):
            return str(self)
            
        def __str__(self):
            return str(self.individual)+str(self.forms)
            
        def add(self, ind):
            sort = ind.sort
            check = False
            for i in self.forms.keys():
                if i == sort.name:
                    form = self.forms[sort.name]
                    check = True
            if check == False:
                form = []
                self.forms[sort.name] = form
            form.append(ind)
            
        def __eq__(self, other):
            if not isinstance(other, distinguishable.elm):
                return False
            return self.individual == other.individual
            
    def __init__(self, ind):
        self.element = distinguishable.elm(ind)
        self.counterparts = []
        
    def __repr__(self):
        return str(self)
            
    def __str__(self):
        return str(self.element)+'|'+str(self.counterparts)

    def addCounterpart(self, ind):
        element = ind.codescriptor()
        counterpart = None
        for i in self.counterparts:
            if i.individual == element:
                counterpart = i
        if counterpart is None:
            counterpart = distinguishable.elm(element)
            self.counterparts.append(counterpart)
        counterpart.add(ind)
        
    def getCounterparts(self):
        return copy(self.counterparts)
            
    def addInstance(self, ind):
        self.element.add(ind)
    
    def clear(self):
        self.counterparts= []
        

