# -*- coding: utf-8 -*-
"""
Created on Mon Aug 15 13:12:55 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from builtins import super
"""
from future import standard_library
standard_library.install_aliases()
"""
from .individual import individual
from copy import deepcopy


class imageUrl(individual):
    
    type = 'ind-imageUrl'
    
    def __init__(self, sort, value = None, icon = None, *args, **kwargs):
        super(imageUrl, self).__init__(sort)
        if value == None:
            self.value = ''
            self.icon = ''
        else:
            self.value = value
            self.icon = icon
                
    def isNil(self):
        return self.value == ''
        
    def equals(self, other):
        return (self.value == other.value) and (self.icon == other.icon)
        
        
    def compareValue(self, other):
        if self.value > other.value:
            return 1
        if self.value < other.value:
            return -1
        if self.icon > other.icon:
            return 1
        if self.icon < other.icon:
            return -1
        return 0
        
    def replicateInd(self):
        return imageUrl(self.sort, self.value)

    #-------------------------------------------------------------
"""
    def toStringInd(self):
        return 
    def parse(self):
        return    
""" 