# -*- coding: utf-8 -*-
"""
Created on Fri Aug 12 14:33:20 2016

@author: akibdpt
"""
from __future__ import division
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import absolute_import
from __future__ import with_statement

import os 
dir_path = os.path.dirname(os.path.realpath(__file__))[:-6]+'config.txt'
file = open(dir_path, 'r')
for line in file:
    if line.strip()[0] == '#':
        continue
    config = line.split('=')
    for i in range(len(config)):
        config[i] = config[i].lower().strip(' ')
    if config[0] != 'coordinate':
        continue
    if config[1] == 'float':
        from .coord.coordinate_float import coordinate, sqrt, pi, sin, cos, tan, acos, atan2, isint, asin
    elif config[1] == 'mpf':
        from .coord.coordinate_mpf import coordinate, sqrt, pi, sin, cos, tan, acos, atan2, isint, asin
    else:
        raise ValueError('Error in config: "'+line+'", '+config[1]+' not recognized')
file.close()
c0 = coordinate(0)
c1 = coordinate(1)
c2 = coordinate(2)
cn1 = coordinate(-1)
c0p5 = coordinate('0.5')
